/* imports */
@import "common.less";

/* variables */

@sidebar-color: #fff;
@sidebar-background-color: #363636;
@sidebar-background-color-darkened: #222222;
@toggle-size: 40px;
@toggle-font-size: @toggle-size / 2;
@tab-bar-height: 30px;
@menu-bar-height: 39px;
@border-offset: 5px;
@tab-bar-button-width: 33px;
@tab-bar-button-size: 20px;
@tab-min-width: 100px;
@tab-max-width: 300px;
@tab-icon-width: 24px;
@tab-cross-width: 24px;
@tab-border-width: 3px;
@tab-color: #444;
@tab-color-active: #000;

@tab-color-border: #b8b8b8;
@tab-color-normal: #ddd;
@tab-color-shown: #eee;
@tab-color-focus: #fff;

@color-default: #ffffff;
@color-primary: #428bca;
@color-success: #5cb85c;
@color-info: #5bc0de;
@color-warning: #f0ad4e;
@color-danger: #d2322d;

@padding-base-vertical: 6px;
@padding-base-horizontal: 12px;

/* vispa styles */

body {
    overflow: hidden;
}

.vispa-nav {
    z-index: 1;
    border-radius: 0px;
}

.vispa-body {
    .vispa-absolute;
    z-index: 0;
}

.vispa-left {
    position: absolute;
    top: 0px;
    bottom: 0px;
    left: 0px;
    width: 0px;
    overflow: hidden;

    background-color: red;
}

.vispa-right {
    position: absolute;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 0px;
    overflow: hidden;

    background-color: red;
}

.vispa-middle {
    .vispa-absolute;
    overflow: hidden;
}

.vispa-top {
    position: absolute;
    top: 0px;
    right: 0px;
    left: 0px;
    height: 0px;
    overflow: hidden;

    background-color: blue;
}

.vispa-bottom {
    position: absolute;
    right: 0px;
    bottom: 0px;
    left: 0px;
    height: 0px;
    overflow: hidden;

    background-color: blue;
}

.vispa-center {
    .vispa-absolute;
}

.vispa-mainmenu-button {
    margin-left: 15px;
}

.vispa-workspace {
    .vispa-absolute;
    display: none;
}

.vispa-workspace > .vispa-modal {
    z-index: 1100;
}

.vispa-workspace-messages > .modal {
    z-index: 1050;
}

.vispa-workspace-extensions {
    .vispa-absolute;
}

.vispa-welcome {
    text-align: center;
    background-color: white;
}

.vispa-sidebar {
    .vispa-absolute;
    color: @sidebar-color;
    background-color: @sidebar-background-color;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    > * {
        width: 100%;
    }
    .vispa-toggle {
        width: @toggle-size;
        height: @toggle-size;
        font-size: @toggle-font-size;
        line-height: @toggle-size;
        text-align: center;
        flex: none;
        cursor: pointer;
        &:hover {
            background-color: @sidebar-background-color-darkened;
        }
        &.active {
            color: @color-primary;
        }
        > img {
            width: 100%;
            height: 100%;
        }
        > button {
            .vispa-absolute;
            width: 100%;
            height: 100%;
            border: none;
            padding: 0px;
            font-size: inherit;
            > i {
                .vispa-absolute(@right: none);
                margin-right: 0px;
                width: @toggle-size;
                height: 100%;
                line-height: inherit;
            }
            > span {
                .vispa-absolute(@left: @toggle-size);
                font-size: 14px;
                text-align: start;
                text-overflow: ellipsis;
                overflow-x: hidden;
            }
        }
    }
    .btn-default, .open > .btn-default {
        color: inherit;
        background-color: @sidebar-background-color;
        border-color: @sidebar-background-color-darkened;
        &:hover, &:focus, &:active {
            color: inherit;
            background-color: @sidebar-background-color-darkened;
        }
    }
    > .vispa-sidebar-header {
        flex: auto;
        display: flex;
        flex-direction: column;
        margin: 0px;
        padding: 0px;
        list-style: none;
    }
    > .vispa-sidebar-body {
        flex: 0 0 0px;
        overflow-x: hidden;
        overflow-y: auto;
        > * {
            position: fixed;
            z-index: 10000;
            left: @toggle-size + 3px; // 3px for the slider
            margin-left: 6px; // for the caret
        }
        > *:not(.caret-left) {
            border-radius: 5px;
            border: @sidebar-background-color solid 1px;
            background-color: @sidebar-background-color;
            padding: @padding-base-vertical @padding-base-horizontal;
            max-height: 100%;
            overflow-y: auto;
        }
        > .caret-left {
            border-bottom: 6px solid transparent;
            border-top: 6px solid transparent;
            border-right: 6px solid @sidebar-background-color;
            display: inline-block;
            vertical-align: top;
            height: 0;
            width: 0;
            margin: 0;
        }
    }
    > .vispa-sidebar-footer {
        flex: none;
        display: flex;
        flex-direction: column;
        margin: 0px;
        padding: 0px;
        list-style: none;
    }
    &.active {
        > .vispa-sidebar-header {
            flex: none;
            flex-direction: row;
        }
        > .vispa-sidebar-body {
            flex: auto;
            > * {
                position: relative;
                left: 0px;
                z-index: 0;
                margin-left: 0px;
                max-height: none;
            }
        }
        > .vispa-sidebar-footer {
            flex-direction: row-reverse;
            > span {
                flex: auto;
            }
        }
    }
}

.vispa-view-wrapper {
    .vispa-absolute;
    background-color: white;
}

.vispa-view-wrapper > div {
    .vispa-absolute;
}

.vispa-view-nav {
    .vispa-absolute(@top: 20px, @right: none, @left: 20px);
    width: 250px;
}

.vispa-view-nav > ul {
    padding: 5px 0px;
    border-radius: 3px;
    background-color: #f5f5fa;
    text-shadow: 0px 1px 0px #fff;
}

.vispa-view-content {
    .vispa-absolute(@left: 270px);
    padding: 0px 20px 10px 20px;
    overflow-x: hidden;
    overflow-y: auto;
    -webkit-overflow-scrolling: touch;
}

.vispa-view-nav .nav > li.active > ul {
    display: block !important;
}

.vispa-view-nav > .nav > li:not(:last-child) {
    margin-bottom: 6px;
}
.vispa-view-nav .lvl2-list > li:not(:last-child) {
    margin-bottom: 3px;
}

.vispa-view-nav > .nav > .vispa-comp-item > a {
    font-weight: bold;
}

.vispa-view-nav .nav a {
    padding: 2px 5px 2px 15px;
}

.vispa-view-nav .nav > li:not(.active) > a {
    color: #555;
}

.vispa-view-nav .nav .nav a {
    padding: 2px 5px 2px 25px;
}

.vispa-view-nav .nav .nav .nav a {
    padding: 2px 5px 2px 35px;
}

.vispa-view-nav .vispa-view-nav-indicator {
    float: right;
    display: none;
    vertical-align: middle;
    margin-right: 2px;
    font-size: 16px;
}

.vispa-view-nav .nav > li.active > a > span.vispa-view-nav-indicator {
    display: block !important;
}

.vispa-view-content h2 {
    margin: 0;
    margin-top: 20px;
    margin-bottom: 10px;
}
.vispa-view-content hr {
    margin: 0;
    margin-top: 10px;
    margin-bottom: 10px;
}
.vispa-view-content h3 {
    margin: 0;
    margin-top: 10px;
    margin-bottom: 15px;
}
.vispa-view-content h4 {
    margin: 0;
    margin-top: 10px;
    margin-bottom: 10px;
}

.vispa-view-content code {
    color: #000;
    background-color: #e5e5ea;
    border: 1px solid #ccc;
    border-radius: 3px;
}

.vispa-view-content .lvl1-label {
    margin-right: 20px;
}
.vispa-view-content .lvl2-label {
    margin-right: 15px;
}

.vispa-view-content .lvl1-container {
    margin-bottom: 60px;
}
.vispa-view-content .lvl2-container {
    margin-bottom: 50px;
    margin-left: 10px;
}
.vispa-view-content .lvl3-container {
    margin-bottom: 40px;
    margin-left: 25px;
}

.prefs-item .form-inline > div.input-group {
    &:first-child > span.input-group-addon {
        min-width: 10rem;
    }
    &:last-child.colorpicker-component.colorpicker-element > .colorpicker {
        position: absolute;
        right: .5em;
        left: initial;
    }
}

.preference-manipulator {
    margin-left: 15px;
}

.preference-manipulator .form-group {
    margin-top: 4px;
}

.preference-manipulator .form-control {
    width: inherit;
    margin-right: 15px;
}

.preference-manipulator .btn-group {
    margin-top: 4px;
    margin-right: 10px;
}

.preference-manipulator div.slider {
    margin-bottom: 4px;
}

.preference-manipulator input.form-control,
.preference-manipulator .bootstrap-select.form-control,
.preference-manipulator div.slider,
.preference-manipulator div.preference-fluid,
.preference-manipulator select.form-control {
    width: 100%;
    min-width: 200px;
    max-width: 600px;
}
.preference-manipulator input.form-control.short {
    width: 200px;
}
.preference-manipulator div.preference-fluid {
    padding: 0px 3px;
    font-weight: bold;
}

.preference-manipulator div.btn-link {
    margin-left: -15px;
    color: #333;
    text-decoration: none;
    font-weight: bold;
}

.workspace-add-dialog label > span.label {
    margin-left: 5px;
}

.workspace-add-dialog div.form-group[optional] {
    display: none;
}

.workspace-add-dialog textarea {
    width: 100%;
    max-width: 100%;
    min-width: 100%;
    max-height: 200px;
}

.workspace-add-dialog-buttons div.btn-link {
    margin-left: -15px;
    color: #333;
    text-decoration: none;
    font-weight: bold;
}

.vispa-logs-wrapper {
    position: absolute;
    bottom: 0px;
    overflow-x: hidden;
    overflow-y: visible;
    z-index: 6;
}
.vispa-logs-wrapper-left {
    left: 0px;
}
.vispa-logs-wrapper-right {
    right: 0px;
}

.vispa-logs {
    position: relative;
    background-color: #e5e5ea;
    padding: 2px 0px;
    border: 1px solid #b8b8b8;
}
.vispa-logs-wrapper-left .vispa-logs {
    border-width: 1px 1px 0px 0px;
    border-top-right-radius: 3px;
}
.vispa-logs-wrapper-right .vispa-logs {
    border-width: 1px 0px 0px 1px;
    border-top-left-radius: 3px;
}

.vispa-log {
    display: none;
    padding: 2px 6px;
    color: #555;
    text-shadow: 0px 1px 0px #fff;
}

.vispa-log > i.glyphicon {
    color: #428bca;
    margin-right: 2px;
}

/* other stuff */

.vispa-slider {
    > div {
        display: inline-block;
        > span {
            margin: 0px 0.5em;
        }
    }
    > input.form-control {
        width: 5em;
    }
}

/* views */

/* dialog */

.vispa-dialogview-dropdownmenu {
    display: inline-block;
    margin-right: 5px;
    cursor: pointer;
}

/* center */

.vispa-ui-split {
    .vispa-absolute;
    display: flex;
    flex-wrap: nowrap;
    &.vispa-ui-horizontal {
        flex-direction: row;
        > .vispa-ui-dragger {
            cursor: ew-resize;
        }
    }
    &.vispa-ui-vertical {
        flex-direction: column;
        > .vispa-ui-dragger {
            cursor: ns-resize;
        }
    }
    > .vispa-ui-wrapper {
        flex-grow: 0;
        flex-shrink: 1;
        position: relative;
    }
    > .vispa-ui-dragger {
        flex: 0 0 2px;
        background-color: #444;
        &.ui-draggable-disabled {
            cursor: default;
        }
    }
}

.vispa-ui-tabber {
    .vispa-absolute;
    > .vispa-ui-tabbar {
        position: absolute;
        top: 0px;
        right: 0px;
        left: 0px;
        display: flex;
        flex-direction: row;
    }
    > .vispa-ui-dropzone {
        display: none;
    }
}

.vispa-ui-tabmove {
    .vispa-ui-spawner {
        display: none;
    }
    .vispa-ui-dropzone {
        display: block;
    }

}

.vispa-ui-dropzone {
    z-index: 10000;
    > .vispa-ui-highlight {
        pointer-events: none;
    }
    > .vispa-ui-highlight:first-child:last-child {
        display: none !important;
    }
    &[data-sector] > .vispa-ui-highlight {
        border: 10px solid @color-success;
    }
    &[data-sector=whole] > .vispa-ui-highlight {
        .vispa-absolute;
    }
    &[data-sector=top] > .vispa-ui-highlight {
        .vispa-absolute(@bottom: 50%);
    }
    &[data-sector=bottom] > .vispa-ui-highlight {
        .vispa-absolute(@top: 50%);
    }
    &[data-sector=left] > .vispa-ui-highlight {
        .vispa-absolute(@right: 50%);
    }
    &[data-sector=right] > .vispa-ui-highlight {
        .vispa-absolute(@left: 50%);
    }
}

.vispa-caret-icon > i > i {
    position: absolute;
    height: 50%;
    width: 50%;
    font-size: 0.7em;
    line-height: 0.7em;
    top: 75%;
    left: 85%;
}

.vispa-body {
    &[data-ws-other-style=darkened] .vispa-ui-tab.vispa-other-ws {
        background-color: #111 !important;
        color: #999;
    }
    &[data-ws-other-style=collapse] .vispa-ui-tab.vispa-other-ws {
        .vispa-comp-label, .vispa-comp-badge, .vispa-comp-close {
            display: none;
        }
        .vispa-caret-icon {
            pointer-events: none;
            i i {
                display: none;
            }
        }
        width: @tab-bar-button-width !important;
    }
}


.vispa-body .vispa-ui-tabber {
    .vispa-absolute;
    > .vispa-ui-tabbar {
        height: @tab-bar-height;
        background-color: @tab-color-normal;
        border-bottom: 1px solid @tab-color-border;
        padding: 0 @border-offset;
        &.vispa-ui-recieving {
            background: @color-success;
        }
        > * {
            height: @tab-bar-height;
            margin-left: -1px;
            font-size: 1em;
            color: @tab-color;
            background-color: @tab-color-normal !important;
            cursor: pointer;
            border-width: 1px;
            border-top-width: 0px;
            border-style: solid;
            border-color: @tab-color-border;
            border-color-bottom: @tab-color-border !important;
            // transition: background-color 50ms;
        }
        > .vispa-ui-tab {
            position: relative;
            display: inline-flex;
            flex-direction: row;
            align-items: center;
            width: @tab-max-width;
            padding: 0px (@tab-border-width - 1px) 0px @tab-border-width;
            &.shown {
                border-bottom-color: transparent;
                background-color: @tab-color-shown !important;
            }
            &.focused {
                background-color: @tab-color-focus !important;
            }
            &:hover {
                color: black;
            }
            &.ui-sortable-helper {
                border-width: 1px;
                border-color: @tab-color-border;
            }
            &[style^="border-color"] {
                padding: 0px;
                border-width: @tab-border-width (@tab-border-width + 1px) @tab-border-width @tab-border-width;
                > .vispa-comp-icon {
                    // width: calc(@tab-bar-height - @tab-border-width);
                }
            }
            > .vispa-comp-icon {
                text-align: center;
                > button {
                    // padding: 0px;
                }
            }
            > .vispa-comp-label {
                // left: @tab-bar-button-width;
                // right: @tab-cross-width;
                flex-grow: 1;
                position: relative;
                > div {
                    position: absolute;
                    width: 100%;
                    white-space: nowrap;
                    overflow: hidden;
                    text-overflow: ellipsis;
                    top: 0;
                }
            }
            > .vispa-comp-badge {
                // position: absolute;
                // right: @tab-cross-width;
            }
            > .vispa-comp-close {
                // right: 0px;
                width: @tab-cross-width;
                text-align: center;
            }
            > * {
                // line-height: @tab-bar-height - 1px;
                // position: absolute;
                // display: inline-block;
                // vertical-align: middle;
                // height: 100%;
            }
        }
        // > .vispa-ui-tab > .vispa-comp-icon, > .vispa-ui-spawner {
        > .vispa-ui-spawner {
            > button {
                border: none;
                background: inherit;
                height: 100%;
                width: @tab-bar-button-width;
                padding: 0px;
            }
        }
        > .vispa-ui-spawner {
            .ws-menu {
                background-color: #e5e5e5;
                margin-top: -5px;
                padding: 5px 0px;
                > a {
                    &:hover, &:focus {
                        background-color: inherit;
                    }
                }
                > .dropdown-menu {
                    top: 5px;
                }
                &.state-disconnected {
                    background-color: #C9302C; // from btn-error
                }
            }
            &.open {
                background-color: @tab-color-shown;
            }
        }
    }
    > .vispa-ui-wrapper, > .vispa-ui-dropzone {
        .vispa-absolute(@top: @tab-bar-height);
    }
    > .vispa-ui-wrapper > .vispa-mainview {
        .vispa-absolute;
        background-color: white;
        display: flex;
        flex-flow: column;
        height: 100%;
        > .vispa-fastmenu {
            &.force {
                min-height: 30px;
            }
            flex: 0 1 auto;
            padding: 2px 6px;
            border-bottom: 1px solid @tab-color-border;
            > div {
                margin: 2px;
            }
        }
        > .vispa-content {
            flex: 1 1 auto;
            overflow: auto;
            position: relative;
        }
    }
}

.vispa-centerview-content-container {
    .vispa-absolute(@top: @tab-bar-height);
}
.vispa-centerview-content-wrapper {
    .vispa-absolute;
    display: none;
}
.vispa-centerview-content {
    .vispa-absolute;
    overflow: auto;
    -webkit-overflow-scrolling: touch;
    background-color: white;
    transition: top 100ms;
    -webkit-transition: top 100ms;
}
.visible-fastmenu .vispa-centerview-content {
    top: @menu-bar-height;
}

.vispa-fastmenu.vispa-fastmenu-centerview {
    position: absolute;
    top: 0px;
    right: 0px;
    left: 0px;
    padding: 0px 8px;
    height: @menu-bar-height;
    box-shadow: inset 0px -1px 0px #b8b8b8;
    background-color: #fff;
    overflow: visible;
}
.vispa-fastmenu.vispa-fastmenu-dialogview {
    width: 100%;
    height: @menu-bar-height;
    padding: 0px 8px;
    box-shadow: inset 0px -1px 0px #e5e5e5;
    overflow-y: visible;
    overflow-x: hidden;
    transition: height 100ms;
    -webkit-transition: height 100ms;
}

.vispa-fastmenu.highlight {
    background-color: rgba(red(@color-primary), green(@color-primary), blue(@color-primary), 0.5);
}
.vispa-fastmenu.accept {
    background-color: rgba(red(@color-success), green(@color-success), blue(@color-success), 0.5);
}

.vispa-fastmenu-entry {
    float: left;
}
.vispa-fastmenu-entry:not(:last-child) {
    margin-right: 10px;
}
.vispa-fastmenu-entry.keepable a.fastmenu-orig,
.vispa-fastmenu-entry.deletable a.fastmenu-del {
    display: block;
}
.vispa-fastmenu-entry a.fastmenu-del,
.vispa-fastmenu-entry.deletable .btn-group,
.vispa-fastmenu-entry.deletable a.fastmenu-orig,
.vispa-fastmenu-entry.keepable a.fastmenu-del {
    display: none;
}

.vispa-centerview-content-loader {
    .vispa-absolute;
    z-index: 1;
    background-color: rgba(0, 0, 0, 0.4);
    box-shadow: inset 0px 0px 20px rgba(0, 0, 0, 0.4);
}

.vispa-centerview-tabs-wrapper {
    position: absolute;
    top: 0px;
    right: 0px;
    left: 0px;
    height: @tab-bar-height;
    background-color: #ddd;
    box-shadow: inset 0px -1px 0px #b8b8b8;
}
.vispa-centerview-tabs-container {
    .vispa-absolute(@right: @border-offset, @left: (@tab-bar-button-width + 2 * @border-offset));
    display: flex;
    flex-direction: row;
    align-items: stretch;
}
.vispa-centerview-tabs-menu-button {
    position: absolute;
    top: (0px - @tab-bar-height);
    left: @border-offset;
    height: @tab-bar-height;
    width: @tab-bar-button-width;
    z-index: 5;
    background-color: #fff;
    box-shadow: inset 1px 0px 0px #b8b8b8,
                inset -1px 0px 0px #b8b8b8;
    cursor: pointer;
}
.vispa-centerview-tabs-menu-button > a {
    position: absolute;
    top: (@tab-bar-height/2 - @tab-bar-button-size/2);
    left: (@tab-bar-button-width/2 - @tab-bar-button-size/2);
    font-size: @tab-bar-button-size;
    line-height: 100%;
    color: inherit;
}
.vispa-centerview-tab {
    position: relative;
    height: (@tab-bar-height - 1px);
    min-width: @tab-min-width;
    max-width: @tab-max-width;
    width: @tab-max-width;
    margin-left: -1px;
    font-weight: 700;
    font-size: 12px;
    color: @tab-color;
    background-color: #ddd;
    cursor: pointer;
    box-shadow: inset 2px 0px 0px #b8b8b8,
                inset -1px 0px 0px #b8b8b8;
    transition: background-color 50ms;
    -webkit-transition: background-color 50ms;
    -moz-transition: background-color 50ms;
    -o-transition: background-color 50ms;
}
.vispa-centerview-tab:first-child {
    margin-left: 0px;
}
.vispa-centerview-tab:hover {
    color: black;
}
.vispa-centerview-tab.active {
    background-color: #fff !important;
    z-index: 10;
}
.vispa-centerview-tab-icon {
    .vispa-absolute(@right: none, @left: 1px);
    width: @tab-icon-width;
    font-size: 14px;
}
.vispa-centerview-tab-icon a {
    color: @tab-color;
}
.vispa-centerview-tab-icon #tab-icon {
    position: relative;
    vertical-align: middle;
    overflow: visible;
}
.vispa-centerview-tab-label {
    .vispa-absolute(@right: @tab-cross-width, @left: @tab-icon-width);
    color: @tab-color;
    text-shadow: 0px 1px 0px rgba(255, 255, 255, 0.75);
    overflow: hidden;
    direction: rtl;
    white-space: nowrap;
}
.vispa-centerview-tab-label span {
    vertical-align: middle;
}
.vispa-centerview-tab-cross {
    .vispa-absolute(@left: none);
    width: @tab-cross-width;
    border-radius: (@tab-cross-width * 0.5);
    font-weight: normal;
    font-size: 14px;
    color: @tab-color;
}
.vispa-centerview-tab-cross i {
    vertical-align: middle;
}
.vispa-centerview-tab-icon a:active,
.vispa-centerview-tab-icon a:hover,
.vispa-centerview-tab-icon a:focus,
.vispa-centerview-tab-active .vispa-centerview-tab-label,
.vispa-centerview-tab-label:hover,
.vispa-centerview-tab-label:active,
.vispa-centerview-tab-label:focus,
.vispa-centerview-tab-cross:hover,
.vispa-centerview-tab-cross:active,
.vispa-centerview-tab-cross:focus {
    color: @tab-color-active;
    text-decoration: none;
}
.vispa-centerview-tab-badge {
    position: relative;
    float: right;
    height: 100%;
    display: table;
    margin-right: @tab-cross-width;
}
.vispa-centerview-tab-badge span {
    vertical-align: middle;
}
.modal {
    position: absolute;
    overflow: hidden;
    margin: 0px;
    display: block;
    > .modal-dialog {
        position: relative;
        height: 100%;
        width: 100%;
        margin: 0px;
        overflow: hidden;
        > .modal-content {
            margin: 10px auto;
            min-width: 300px;
            max-width: 75%;
            width: 600px;
            max-height: calc(~"100% - 20px");
            overflow: hidden;
            display: flex;
            flex-direction: column;
            > .modal-header, > .modal-footer {
                flex: none;
            }
            > .modal-body {
                overflow-x: hidden;
                overflow-y: auto;
                flex: auto;
            }
        }
    }
}


/* overwrite vendor classes */
.bootbox.modal {
    position: absolute;
    top: 0px;
    right: 0px;
    bottom: 0px;
    left: 0px;
    padding-top: 40px;
    background-color: rgba(0, 0, 0, 0);
    overflow: auto;
    outline: none;
}

.modal.feedback textarea {
    width: 100%;
    max-width: 100%;
    max-height: 300px;
    height: 150px;
    padding: 10px;
    margin: 10px 0px;
}

.navbar-nav > li > a {padding-top:10px !important; padding-bottom:10px !important;}
